from Node import Node
import logging
import Utility
import hashlib
import Config
import random

genesisBlock = ("I am the first block")
#
# class Role:
#     def __init__(self):
#         self.role =

class OverlayNode(Node):
    def __init__(self,id,network,weight):
        Node.__init__(self,id,network,weight)


        self.blockchain = [genesisBlock]
        self.currentRound = 0  # round is equivalent ot block height
        self.step = 0
        self.currentRoleCount = 20
        self.currentRole = "BLOCK_PROPOSER"

        self.startNodeLifeCycleGenerator = self.startNodeLifeCycle()
        # adding initial task of bootstraping node.and it only contains ba* resume tasks
        # self.ResumeTasks.append(("nextOn", self.startNodeLifeCycleGenerator,))
        self.ResumeTasks['1'].append(("nextOn", self.startNodeLifeCycleGenerator,))
        self.commands.update({})



    # def processMessage(self,time,payload):
    #     super(OverlayNode, self).processMessage(time,payload)
    #     print("from overlay node : "+str(payload))

    def startNodeLifeCycle(self):
        '''THis is monolithic algorand algorithm for a NOde'''
        self.logger.info("Life cycle started")

        while True:
            #increment round number


            blockForBA = None
            # Checking if I am a Block Propser
            previousHash = hashlib.sha256(self.blockchain[-1].encode('utf-8')).hexdigest()
            seed = ( previousHash,self.currentRound,0)
            hash, proof, j = Utility.sortition(self.sk,seed,Config.tou_proposer, Config.ROLE_BLOCK_PROPOSER, self.weight, self.network.badaW, self.pk)


            if j > 0 : # only the block proposer commity mebers can enter here
                self.logger.info("selection for BLOCK PROPOSAL with  J ="+str( j))
                min_sha_priority = None
                # min_sub_user_index = None
                # msg_to_broadcast = ( currentRound, hash , min_sub_user_index , min_sha_priority )
                for sub_user_index in range(self.weight):
                    input_to_SHA256 = (hash , sub_user_index,)
                    sha256_hash = hashlib.sha256((str(input_to_SHA256)).encode('utf-8')).hexdigest()
                    if not min_sha_priority :
                        min_sha_priority = sha256_hash
                        min_sub_user_index = sub_user_index
                    if sha256_hash < min_sha_priority:
                        min_sha_priority =  sha256_hash
                        min_sub_user_index = sub_user_index


                priority_msg_to_broadcast = ( Config.PRIORITY_MSG_type,self.currentRound, hash , min_sub_user_index , min_sha_priority,proof )
                self.logger.info("broadcsting priority message : "+str(priority_msg_to_broadcast))
                self.broadcast(self.network.time, priority_msg_to_broadcast)


                self.logger.info("WAITING FOR PRIORITY MESSAGES from others")
                yield "resume",Config.lambda_proposer

                greater_flag = True

                msgs = self.uniqueReceivedMessages.pop(Config.PRIORITY_MSG_type)
                for priority_msg_other in msgs :
                    if min_sha_priority > priority_msg_other[4]:
                        greater_flag = False

                if greater_flag :
                    self.logger.info("I am the block proposer")
                    '''
                    BLOCK_PROPOSAL_MSG_to_broadcast : ("BLOCK_PROPOSAL_MSG", previousblockhash,A random string as txns,Nod`s priority payload)
                    '''
                    BLOCK_PROPOSAL_MSG_to_broadcast = (Config.BLOCK_PROPOSAL_MSG_type, previousHash,Utility.pseudoRandomGenerator(random.randint(0,1000)),priority_msg_to_broadcast[1:])
                    self.logger.info("broadcsting BLOCK Proposal Message : " + str(BLOCK_PROPOSAL_MSG_to_broadcast))
                    self.broadcast(self.network.time, BLOCK_PROPOSAL_MSG_to_broadcast)
                    blockForBA = (previousHash,BLOCK_PROPOSAL_MSG_to_broadcast[2])
                else:  # others than block proposers
                    # everybody except highest priority block proposer is waiting for lambda_proposer+ lambda_block 33 seconds
                    yield "resume", Config.lambda_proposer + Config.lambda_block

            else: # others than block proposers
                # everybody is waiting for lambda_proposer+ lambda_block 33 seconds
                yield "resume", Config.lambda_proposer+Config.lambda_block

            # TODO:done : drop any priority messages in queue
            try :
                self.uniqueReceivedMessages.pop(Config.PRIORITY_MSG_type)
            except Exception:
                pass
            # print("NOde id :"+self.id)
            # print(self.uniqueReceivedMessages)

            ######### Performing selection of block BA* ############################
            if not (self.uniqueReceivedMessages[Config.BLOCK_PROPOSAL_MSG_type] or blockForBA) :
                blockForBA = (previousHash,"Empty")
            elif not blockForBA :
                # Todo select block from highest priority node
                blockForBA = (self.uniqueReceivedMessages[Config.BLOCK_PROPOSAL_MSG_type][0][1],
                              self.uniqueReceivedMessages[Config.BLOCK_PROPOSAL_MSG_type][0][2])
                pk = self.uniqueReceivedMessages[Config.BLOCK_PROPOSAL_MSG_type][0][3][4]
                hash = self.uniqueReceivedMessages[Config.BLOCK_PROPOSAL_MSG_type][0][3][1]
                proof = self.uniqueReceivedMessages[Config.BLOCK_PROPOSAL_MSG_type][0][3][4]
                w = self.network.pk_weight_map.get(pk)
                seed = (previousHash, self.currentRound, 0)
                # TODO verify block proposal

                j = Utility.verifySort(pk, hash, proof, seed, Config.tou_proposer, Config.ROLE_BLOCK_PROPOSER, w, self.network.badaW)
                if j :
                    self.logger.log("it is a valid block proposed message with j : "+str(j))

            #todo : DONE : drop block proposal msges
            try :
                self.uniqueReceivedMessages.pop(Config.BLOCK_PROPOSAL_MSG_type)
            except Exception  as e:
                self.logger.error(e)

            print(blockForBA)
            ######### END : Performing selection of block BA* ############################




            '''     START : REDUCTION ALGORITHM       '''
            # reduct_step_1 = 1
            # reduct_seed = (previousHash, self.currentRound, reduct_step_1)
            # reduct_hash, reduct_proof, reduct_j = Utility.sortition(self.sk, reduct_seed, Config.tou_step, Config.ROLE_COMMITEE_FOR_VOTE,
            #                                    self.weight, self.network.badaW, self.pk)
            #
            # if reduct_j :
            #     self.logger.info("selection for VOTIN COMMITEE with  J =" + str(reduct_j))

            yield "resume", 9
            self.logger.info(self.uniqueReceivedMessages)
            yield "resume",400
            '''     END : REDUCTION ALGORITHM       '''
            '''
             TODo check if node is selected as BLOCK_PROPOSER
                if yes 
                then
                    select highest priority subuser and gossip the message
                    wait for lambda_proposer=3 sec and hear other block propositions
                    take decision based on received propositions and determine if himself is a highest priority or not
                    if yes
                        broacast the block proposal <format of block proposal>
                
                everybody except highest priority block proposer waits for  t_proposer+t_block time to here the proposed block
                    if received proposal
                    then 
                        start BA* with this new block
                        validate sortition of proposed block
                        if yes
                        then
                            start reduction
                        else 
                            vote for empty block
                    else 
                        start BA* with empty block
                
                
                        
                        
            '''


            pass

        pass


























































class A(object):
    def __init__(self,id):
        self.id = id
        self.commands = {"sendMessage": self.sendMessage,
                         }

    def sendMessage(self):
        pass

    def process(self,param):
        print("from A " +str(param) )
        param.pop(0)
        param.pop(0)

class B(A):
    def __init__(self,id):
        A.__init__(self, id)
        self.commands.update({"hello":self.working})



    def working(self):
        pass

    def process(self,param):
        super(B, self).process(param)
        print("from B" + str(param))


if __name__ == '__main__':
    x = [1]
    if x:
        print('yup')